#![allow(deprecated)]
use std::fmt;
use std::str;
/// The base map style. Default STREET if unspecified.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum GeoBaseTileset {
    #[serde(rename = "STREET")]
    Street,
    #[serde(rename = "SATELLITE")]
    Satellite,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl GeoBaseTileset {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            GeoBaseTileset::Street => "STREET",
            GeoBaseTileset::Satellite => "SATELLITE",
            GeoBaseTileset::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for GeoBaseTileset {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for GeoBaseTileset {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for GeoBaseTileset {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<GeoBaseTileset, conjure_object::plain::ParseEnumError> {
        match v {
            "STREET" => Ok(GeoBaseTileset::Street),
            "SATELLITE" => Ok(GeoBaseTileset::Satellite),
            v => v.parse().map(|v| GeoBaseTileset::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for GeoBaseTileset {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<GeoBaseTileset, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the GeoBaseTileset enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
